#include "accelerometer.h"
 
 static spi_master_hw_instance_t spi_acc_;
 
 /**@brief   Function for initiating the accelerometer
 * @details TODO define later
 *          
 *          
 * @pre 
 */
void accelerometer_init(void)
{
	
	spi_master_config_t * spi_acc_config;
	
	spi_acc_config->SPI_Pin_MISO = 	SPI_PSELMISO0;
	spi_acc_config->SPI_Pin_MOSI = 	SPI_PSELMOSI0;
	spi_acc_config->SPI_Pin_SCK = 	SPI_PSELSCK0;
	spi_acc_config->SPI_Pin_SS = 		SPI_PSELSS0;
	spi_acc_config->SPI_Freq = 			20000UL;  /**< Slave clock frequency. */
	spi_acc_config->SPI_CONFIG_CPHA = 0;
	spi_acc_config->SPI_CONFIG_CPOL = 0;
	spi_acc_config->SPI_CONFIG_ORDER = 0; //MSB first
	
	uint32_t result = spi_master_open(spi_acc_, spi_acc_config);
	
	if (result == NRF_SUCCESS)
	{
		simple_uart_putstring((const uint8_t *)"\n\rSuccess\n\r");
	}
	else if (result == NRF_ERROR_INVALID_STATE)
	{
		simple_uart_putstring((const uint8_t *)"\n\rError Invalid state\n\r");
	}
	else if (result == NRF_ERROR_NULL)
	{
		simple_uart_putstring((const uint8_t *)"\n\rError null\n\r");
	}
	else if (result == NRF_ERROR_NOT_SUPPORTED)
	{
		simple_uart_putstring((const uint8_t *)"\n\rError not supported\n\r");
	}
	else 
	{
		simple_uart_putstring((const uint8_t *)"\n\rNo Success:\n\r");
	}
	
}

/**@brief   Function for testing the accelerometer
 * @details Ask or the device id
 *          
 */
void accelerometer_test(void)
{
	uint8_t tx_buf [4];
	uint8_t rx_buf [4];
	tx_buf[0] = 6;
	tx_buf[1] = 128;
	tx_buf[2] = 0;
	tx_buf[3] = 0;
	
	rx_buf[0] = 0;
	rx_buf[1] = 0;
	rx_buf[2] = 0;
	rx_buf[3] = 0;
	
	spi_master_send_recv(spi_acc_, tx_buf, 4, rx_buf, 4);
	
	simple_uart_putstring((const uint8_t *)"\n\r\n\rSend\n\r");
	simple_uart_put(tx_buf[0]);
	simple_uart_put(tx_buf[1]);
	simple_uart_put(tx_buf[2]);
	simple_uart_put(tx_buf[3]);
	
	
	simple_uart_putstring((const uint8_t *)"\n\rReceived\n\r");
	simple_uart_put(rx_buf[0]);
	simple_uart_put(rx_buf[1]);
	simple_uart_put(rx_buf[2]);
	simple_uart_put(rx_buf[3]);
	
}